/****************************************************************
** Program name: Final Project
** Author: Milad Mikeal
** Date: 11/23/18
** Description: Abstract base class. Spaces can either be a
 * soldier, a mine, or a comrade.
****************************************************************/
#include "Space.hpp"

/****************************************************************
** Description: Constructor. Initializes pointers to null and
 * type to space.
****************************************************************/
Space::Space() {
    top = right = left = bottom = nullptr;
    type = ' ';
}

/****************************************************************
** Description: Set top pointer.
****************************************************************/
void Space::setTop(Space *t) {
    top = t;
}

/****************************************************************
** Description: Get top pointer.
****************************************************************/
Space* Space::getTop() {
    return top;
}

/****************************************************************
** Description: Set right pointer.
****************************************************************/
void Space::setRight(Space *r) {
    right = r;
}

/****************************************************************
** Description: Get right pointer.
****************************************************************/
Space* Space::getRight() {
    return right;
}

/****************************************************************
** Description: Set left pointer.
****************************************************************/
void Space::setLeft(Space *l) {
    left = l;
}

/****************************************************************
** Description: Get left pointer.
****************************************************************/
Space* Space::getLeft() {
    return left;
}

/****************************************************************
** Description: Set bottom pointer.
****************************************************************/
void Space::setBottom(Space *b) {
    bottom = b;
}

/****************************************************************
** Description: Get bottom pointer.
****************************************************************/
Space* Space::getBottom() {
    return bottom;
}

/****************************************************************
** Description: Set type.
****************************************************************/
void Space::setType(char t) {
    type = t;
}

/****************************************************************
** Description: Get type.
****************************************************************/
char Space::getType() {
    return type;
}